<!--
  ~ iparapheur Web
  ~ Copyright (C) 2019-2025 Libriciel SCOP
  ~
  ~ This program is free software: you can redistribute it and/or modify
  ~ it under the terms of the GNU Affero General Public License as published by
  ~ the Free Software Foundation, either version 3 of the License, or
  ~ (at your option) any later version.
  ~
  ~ This program is distributed in the hope that it will be useful,
  ~ but WITHOUT ANY WARRANTY; without even the implied warranty of
  ~ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  ~ GNU Affero General Public License for more details.
  ~
  ~ You should have received a copy of the GNU Affero General Public License
  ~ along with this program. If not, see <http://www.gnu.org/licenses/>.
  -->

<div>
  <form class="ls-form" [formGroup]="workflowForm">

    <div class="form-group row">

      <label
        class="col-4 col-form-label"
        for="selectCreationWorkflow"
        [innerText]="commonMessages.CREATION_WORKFLOW">
      </label>

      <div class="col-8">
        <ng-select
          (search)="updateAvailableWorkflowsList($event)"
          [(ngModel)]="subtype.creationWorkflowId"
          (ngModelChange)="updateCurrentCreationWorkflowSteps($event)"
          [items]="availableWorkflows"
          [multiple]="false"
          [placeholder]="messages.CHOOSE_A_WORKFLOW"
          [ngbTooltip]="getWorkflowCreationTooltip()"
          [disableTooltip]="!getWorkflowCreationTooltip()"
          [disabled]="!subtype.validationWorkflowId"
          [notFoundText]="commonMessages.NOT_FOUND"
          [clearAllText]="commonMessages.CLEAR"
          (focusout)="requestWorkflows()"
          bindLabel="name"
          bindValue="key"
          class="input-group ls-select"
          id="selectCreationWorkflow"
          formControlName="selectCreationWorkflow"
          selectOnTab>

          <ng-template let-item="item" ng-option-tmp>
            {{ item.name }}
          </ng-template>

          <ng-template let-item="item" ng-label-tmp>
            <span
              class="ng-value-label"
              [innerText]="item.name">
            </span>
          </ng-template>

        </ng-select>
      </div>
    </div>

    <div class="form-group row">

      <label
        class="col-4 col-form-label"
        for="selectValidationWorkflow"
        [innerText]="commonMessages.VALIDATION_WORKFLOW">
      </label>

      <div class="col-8">
        <ng-select
          (search)="updateAvailableWorkflowsList($event)"
          [(ngModel)]="subtype.validationWorkflowId"
          (ngModelChange)="updateCurrentValidationWorkflowSteps($event)"
          [items]="availableWorkflows"
          [multiple]="false"
          bindLabel="name"
          bindValue="key"
          class="input-group ls-select"
          [notFoundText]="commonMessages.NOT_FOUND"
          [clearAllText]="commonMessages.CLEAR"
          id="selectValidationWorkflow"
          formControlName="selectValidationWorkflow"
          [placeholder]="messages.CHOOSE_A_WORKFLOW"
          [ngbTooltip]="getWorkflowValidationTooltip()"
          [disableTooltip]="!getWorkflowValidationTooltip()"
          (focusout)="requestWorkflows()"
          selectOnTab>

          <ng-template let-item="item" ng-option-tmp>
            {{ item.name }}
          </ng-template>

          <ng-template let-item="item" ng-label-tmp>
            <span
              class="ng-value-label"
              [innerText]="item.name">
            </span>
          </ng-template>

        </ng-select>
      </div>
    </div>

    <div
      class="form-group row"
      *ngIf="doesWorkflowDefinitionContainsAction(validationWorkflowDefinition, actionEnum.ExternalSignature)">

      <label
        class="col-4 col-form-label"
        for="selectExternalSignatureConfig"
        [innerText]="messages.EXTERNAL_SIGNATURE_CONFIGURATION">
      </label>

      <div
        class="col-8 large-tooltip"
        *ngIf="doesWorkflowDefinitionContainsAction(validationWorkflowDefinition, actionEnum.ExternalSignature)">

        <ng-select
          (search)="updateAvailableExternalSignatureConfigsList($event)"
          [(ngModel)]="subtype.externalSignatureConfig"
          [items]="availableExternalSignatureConfigurations"
          [multiple]="false"
          [notFoundText]="commonMessages.NOT_FOUND"
          [clearAllText]="commonMessages.CLEAR"
          [placeholder]="messages.CHOOSE_A_CONFIGURATION"
          bindLabel="name"
          class="input-group ls-select"
          id="selectExternalSignatureConfig"
          formControlName="selectExternalSignatureConfig"
          selectOnTab>

          <ng-template let-config="item" ng-option-tmp>
            {{ config.name }}
          </ng-template>

          <ng-template let-config="item" ng-label-tmp>
            <span
              class="ng-value-label"
              [innerText]="config.name">
            </span>
          </ng-template>

        </ng-select>
        <div class="d-flex align-items-center mt-3">
          <div class="custom-control custom-checkbox">
            <input
              id="isExternalSignatureAutomatic"
              class="custom-control-input"
              type="checkbox"
              formControlName="isExternalSignatureAutomatic"
              [(ngModel)]="subtype.externalSignatureAutomatic">
            <label
              class="custom-control-label fw-normal"
              for="isExternalSignatureAutomatic"
              [innerText]="messages.AUTOMATIC_EXTERNAL_SIGNATURE">
            </label>
          </div>

          <ng-template #externalSignatureTooltip>
            <div
              class="text-start px-2 pt-2"
              [innerHTML]="messages.EXTERNAL_SIGNATURE_TOOLTIP">
            </div>
          </ng-template>

          <fa-icon
            class="p-2"
            [icon]="infoIcon"
            [ngbTooltip]="externalSignatureTooltip">
          </fa-icon>
        </div>

      </div>
    </div>

    <div
      class="form-group row"
      *ngIf="doesWorkflowDefinitionContainsAction(validationWorkflowDefinition, actionEnum.SecureMail)">

      <label
        class="col-4 col-form-label"
        for="selectSecureMailServer"
        [innerText]="messages.SECURE_MAIL_CONFIGURATION">
      </label>

      <div class="col-8">
        <ng-select
          (search)="updateAvailableSecureMailServerList($event)"
          [(ngModel)]="subtype.secureMailServerId"
          [items]="availableSecureMailServers"
          [multiple]="false"
          bindLabel="id"
          bindValue="id"
          class="input-group ls-select"
          [notFoundText]="commonMessages.NOT_FOUND"
          [clearAllText]="commonMessages.CLEAR"
          id="selectSecureMailServer"
          formControlName="selectSecureMailServer"
          [placeholder]="messages.CHOOSE_A_CONFIGURATION"
          selectOnTab>

          <ng-template let-server="item" ng-option-tmp>
            {{ server.name }}
          </ng-template>

          <ng-template let-server="item" ng-label-tmp>
            <span
              class="ng-value-label"
              [innerText]="server.name">
            </span>
          </ng-template>

        </ng-select>
      </div>
    </div>

    <div
      class="form-group row"
      *ngIf="doesWorkflowDefinitionContainsAction(validationWorkflowDefinition, actionEnum.Signature) &&  type?.protocol !== protocolEnum.Helios ">

      <label
        class="col-4 col-form-label"
        [innerText]="messages.SIGNATURE_OPTIONS">
      </label>

      <div class="col-8 col-form-label">
        <div class="custom-control custom-checkbox">
          <input
            id="isDigitalSignatureMandatory"
            class="custom-control-input"
            type="checkbox"
            formControlName="isDigitalSignatureMandatory"
            [(ngModel)]="subtype.digitalSignatureMandatory">
          <label
            class="custom-control-label fw-normal"
            for="isDigitalSignatureMandatory"
            [innerText]="messages.DIGITAL_SIGNATURE_MANDATORY">
          </label>
        </div>
      </div>
    </div>

    <div
      class="form-group row"
      *ngIf="doesWorkflowDefinitionContainsAction(validationWorkflowDefinition, actionEnum.Seal)">

      <label
        class="col-4 col-form-label"
        for="selectSealCertificate"
        [innerText]="messages.SEAL">
      </label>

      <div class="col-8">

        <ng-select
          (search)="updateAvailableSealCertificates($event)"
          [(ngModel)]="subtype.sealCertificate"
          [multiple]="false"
          [compareWith]="compareByIdFn"
          [notFoundText]="commonMessages.NOT_FOUND"
          [clearAllText]="commonMessages.CLEAR"
          [placeholder]="messages.CHOOSE_A_SEAL_CERTIFICATE"
          id="selectSealCertificate"
          bindLabel="name"
          formControlName="selectSealCertificate"
          selectOnTab>

          <ng-option
            *ngFor="let sealCertificate of sealCertificates"
            [value]="sealCertificate"
            [innerText]="sealCertificate.name | namePipe">
          </ng-option>

        </ng-select>

        <div class="mt-2 custom-control custom-checkbox">
          <input
            id="isSealAutomatic"
            class="custom-control-input"
            type="checkbox"
            formControlName="isSealAutomatic"
            [(ngModel)]="subtype.sealAutomatic">
          <label
            class="custom-control-label fw-normal"
            for="isSealAutomatic"
            [innerText]="messages.AUTOMATIC_SEAL">
          </label>
        </div>
      </div>
    </div>

    <div
      class="form-group row"
      *ngIf="!validationWorkflowDefinition">
      <label
        class="col-4 col-form-label"
        for="selectionScriptEditor"
        [innerText]="messages.SELECTION_SCRIPT">
      </label>
      <app-monaco-editor
        class="col-8 border-light"
        id="selectionScriptEditor"
        language="java"
        [code]="subtype?.workflowSelectionScript || ''"
        (codeChange)="updateSelectionScript($event)">
      </app-monaco-editor>
      <div
        class="col-12">
        <span
          class="mt-1 float-end"
          [ngClass]="{
            'text-secondary': subtype.workflowSelectionScript?.length < maxSelectionScriptLength,
            'text-warning': subtype.workflowSelectionScript?.length >= maxSelectionScriptLength,
            'text-danger': subtype.workflowSelectionScript?.length >= 65535
          }"
          [innerText]="getNbCharInScriptLabel(subtype.workflowSelectionScript)">
        </span>
      </div>
    </div>

    <div
      class="form-group row"
      *ngIf="!!subtype.validationWorkflowId">
      <label
        class="col-4 col-form-label"
        for="workflowDefinition"
        [innerText]="commonMessages.WORKFLOW_STEPS_DEFINITION">
      </label>
      <div
        class="col-8"
        id="workflowDefinition">
        <span
          *ngIf="!!creationWorkflowDefinition"
          class="text-secondary mb-1"
          [innerText]="commonMessages.CREATION_WORKFLOW">
        </span>
        <app-workflow-steps
          *ngIf="!!creationWorkflowDefinition"
          id="creationSteps"
          [tenantId]="tenantId"
          [workflowDefinition]="creationWorkflowDefinition"
          [originDesk]="dummyOriginDesk"
          [showStart]="true"
          [showEnd]="false">
        </app-workflow-steps>
        <span
          *ngIf="!!creationWorkflowDefinition"
          class="text-secondary my-2"
          [innerText]="commonMessages.VALIDATION_WORKFLOW">
        </span>
        <app-workflow-steps
          *ngIf="!!validationWorkflowDefinition"
          id="validationSteps"
          [tenantId]="tenantId"
          [allowVariableDeskEdition]="false"
          [workflowDefinition]="validationWorkflowDefinition"
          [originDesk]="dummyOriginDesk"
          [showStart]="!creationWorkflowDefinition"
          [showEnd]="true">
        </app-workflow-steps>
      </div>
    </div>

  </form>
</div>
